      
class de_inputs{
  constructor(){
    this.value;
  }
  selectColumn(matrix, ascii, table, value){
    let i = 1;
    var num = value.charCodeAt(0)-ascii.firstLetter+1;
    if(matrix.colsclean == true){
      while(table.rows[i] != undefined){
        table.rows[i].cells[num].style.backgroundColor = "lightblue";        
        i++;
        num--;
        if(num <= 0){
          num = 26;
        }
      }
      matrix.coloredCol = num;
      matrix.colsclean = false;
      matrix.ciphered = false;
    }
  }
  deselectColumn(matrix, ascii, table){
    let i = 1;
    let num = matrix.coloredCol;
    while(table.rows[i] != undefined){
      table.rows[i].cells[num].style.backgroundColor = "white";
      i++;
      num--;
      if(num <= 0){
          num = 26;
      }
    }
    if((matrix.rowsclean == false) && (matrix.ciphered == false)){
      let temp = matrix.coloredCol-(matrix.lastRow.charCodeAt(0)-65);
      if(temp <= 0){
          temp = temp + 26;
      }
      table.rows[matrix.coloredRow].cells[temp].style.backgroundColor = "lightblue";
    }
    matrix.colsclean = true;
  }
  selectRow(matrix, ascii, table, value){
    let i = 0;       
    var num = value.charCodeAt(0)-ascii.firstLetter+1;
    while(table.rows[num].cells[i] != undefined){
      table.rows[num].cells[i].style.backgroundColor = "lightblue";
      i++;
    }
    matrix.coloredRow = num;
    matrix.rowsclean = false;
    matrix.ciphered = false;
  }
  deselectRow(matrix, ascii, table){
    let i = 0;
    while(table.rows[matrix.coloredRow].cells[i] != undefined){
      table.rows[matrix.coloredRow].cells[i].style.backgroundColor = "white";
      i++;
    }
    if((matrix.colsclean == false) && (matrix.ciphered == false)){
      let temp = matrix.coloredCol-(matrix.lastRow.charCodeAt(0)-65);
      if(temp <= 0){
          temp = temp + 26;
      }
      table.rows[matrix.coloredRow].cells[temp].style.backgroundColor = "lightblue";
    }
    matrix.rowsclean = true;
  }
}       

class DeciphreMachine{
  constructor(){
    this.plaintext;
    this.key;
    this.ciphre;
  }
  extendKey(){
    while(this.key.length < this.plaintext.length){
      this.key = this.key.concat("", this.key);
    }
  }
  decipherManual(matrix, ascii, pl_letter, cip_letter, final){
    var start = ascii.alphabet[0];
    var end = ascii.alphabet.length;
    start = start.charCodeAt(0);
    var p = pl_letter.charCodeAt(0);
    var c = cip_letter.charCodeAt(0);
    var shift = c - start;
    var output = p - shift;
    if(output <start){
      output = output + end;
    }
    output = String.fromCharCode(output);
    document.getElementById(final).innerHTML += output;  
    matrix.ciphered = true;
  }
  decipherAuto(ascii){
    this.ciphre = "";
    var i = 0;
    var p, c;
    var start = ascii.alphabet[0];
    var end = ascii.alphabet.length;
    start = start.charCodeAt(0);
    while(this.plaintext.charAt(i) != ''){
      p = this.plaintext.charAt(i).charCodeAt(0);
      c = this.key.charAt(i).charCodeAt(0);
      var shift = c - start;
      var output = p - shift;
      if(output<start){
        output = output + end;
      }
      output = String.fromCharCode(output);
      this.ciphre +=output;
      i++;
    }
  }
  checkCiphre(final){
    return this.ciphre.localeCompare(document.getElementById(final).innerHTML);
  }
}
function loadDefault(plainletter, cipherletter){
  const normal = 97;
  const capital = 65;
  var firstLetter = capital;
  var htmltable = document.getElementById("table_1");
  var cipheredtext;
  const ascii = new ASCIIarray(firstLetter,firstLetter+26);
  ascii.fillArray();
  const matrix = new table(ascii.alphabet.length+1);
  matrix.buildHeaders(ascii);
  matrix.buildTable(ascii);
  matrix.printTable(htmltable);
  ascii.fillSelect(plainletter);
  ascii.fillSelect(cipherletter);
  const encryptor = new DeciphreMachine();
  encryptor.plaintext = "";
  encryptor.key = "";
  const plainInput = new de_inputs();
  const cipherInput = new de_inputs();
  document.getElementById(plainletter).addEventListener("input", function(){
    if (matrix.colsclean == true){
      plainInput.selectColumn(matrix, ascii, htmltable, this.value);
    } else {
      plainInput.deselectColumn(matrix, ascii, htmltable);
      plainInput.selectColumn(matrix, ascii, htmltable, this.value);
    }
  });
  document.getElementById(cipherletter).addEventListener("input", function(){
    if (matrix.rowsclean == true){
      cipherInput.selectRow(matrix, ascii, htmltable, this.value);
      matrix.lastRow = this.value;
      if(matrix.colsclean == false && matrix.rowsclean == false)
        matrix.highlight();         //edi
    } else {
      cipherInput.deselectRow(matrix, ascii, htmltable);
      cipherInput.selectRow(matrix, ascii, htmltable, this.value);
      matrix.lastRow = this.value;
      if(matrix.colsclean == false && matrix.rowsclean == false)
        matrix.highlight();     //edi
    }
  });
  document.getElementById("button_1").addEventListener("click", function(){
    var plain = document.getElementById(plainletter).selectedIndex;
    var cipher = document.getElementById(cipherletter).selectedIndex;
    if((plain == -1) || (cipher == -1)){
      print_modal("modal","chyba","Zadejte obě písmena.");
    } else {
      var pl_letter = document.getElementById(plainletter).value;
      var cip_letter = document.getElementById(cipherletter).value;
      encryptor.decipherManual(matrix, ascii, pl_letter, cip_letter, "final_1");
      plainInput.deselectColumn(matrix, ascii, htmltable);
      cipherInput.deselectRow(matrix, ascii, htmltable);
      document.getElementById(plainletter).selectedIndex = -1;
      document.getElementById(cipherletter).selectedIndex = -1;
      document.getElementById("final_1").style.backgroundColor = "white";
      if(document.getElementById("zvyrazni_td")){
        let tmp = document.getElementById("zvyrazni_td");
        tmp.removeAttribute("id");
      }
    }
  });
  document.getElementById("plain_1").addEventListener("keyup", function(){
    var element = document.getElementById("plain_1");
    element.value = element.value.replace(/[^a-z,A-Z]+/, '');
  });
  document.getElementById("key_1").addEventListener("keyup", function(){
    var element = document.getElementById("key_1");
    element.value = element.value.replace(/[^a-z, A-Z]+/, '');
  });
  document.getElementById("plain_1").addEventListener("focusout", function(){
    encryptor.plaintext = this.value;
    if((this.value != "") && (encryptor.key != "")){
      encryptor.extendKey(ascii);
      encryptor.decipherAuto(ascii);
    }
  });
  document.getElementById("key_1").addEventListener("focusout", function(){
    encryptor.key = this.value;
    if((this.value != "") && (encryptor.plaintext != "")){
      encryptor.extendKey(ascii);
      encryptor.decipherAuto(ascii);
    }
  });
  document.getElementById("check_1").addEventListener("click", function(){
    var ok = encryptor.checkCiphre("final_1");
    if(ok == 0){
      document.getElementById("final_1").style.backgroundColor = "rgba(0,255,0,0.4)";
    } else{
      document.getElementById("final_1").style.backgroundColor = "rgba(255,0,0,0.4)";
    }
  });
  //edit: maze posledni pismenos
    document.getElementById("reset_1").addEventListener("click", function(){
    //document.getElementById("plain_1").value = "";
    //document.getElementById("key_1").value = "";
      let txt = document.getElementById("final_1");
      txt.innerHTML = txt.innerHTML.substring(0, txt.innerHTML.length - 1);
  });
}


loadDefault('plain-letter_1', 'cipher-letter_1');