class ASCIIarray{
  constructor(min, max){
    this.firstLetter = min;
    this.lastLetter = max;
    this.alphabet = [];
  }
  fillArray(){
    for(let i=0 ; i < this.lastLetter-this.firstLetter;i++){
      this.alphabet[i]=String.fromCharCode(this.firstLetter+i);
    }
  }
  rotateArray(){
    var temp;
    temp = this.alphabet[0];
    for(let i=1;i<this.alphabet.length;i++){
      this.alphabet[i-1]=this.alphabet[i];
    }
    this.alphabet[this.alphabet.length-1]=temp;
    return this.alphabet;
  }
  fillSelect(select){
    var selection = document.getElementById(select);
    for (let i = 0; i < this.alphabet.length; i++){
      var option = document.createElement("option");
      option.value = this.alphabet[i];
      option.text = this.alphabet[i];
      selection.add(option);
      
    }
    selection.selectedIndex = -1;
  }
}
class table{
  constructor(size){
    this.size = size;
    this.newtable = [];
    this.coloredRow;
    this.coloredCol;
    this.rowsclean = true;
    this.colsclean = true;
    this.ciphered = false;
    for(let i=0; i < size; i++){
      this.newtable[i]=[];
    }
  }
  buildHeaders(ascii){
    this.newtable[0][0]=" ";
    for (let i=1;i<this.newtable.length;i++) {
      this.newtable[0][i] = ascii.alphabet[i-1];
      this.newtable[i][0] = ascii.alphabet[i-1];
    } 
  }
  buildTable(ascii){
    for (let i=1 ; i<this.newtable.length ; i++) {
      for (let j=1; j<this.newtable.length; j++) {
        this.newtable[i][j]=ascii.alphabet[j-1];
      }
      ascii.rotateArray();
    }   
  }
  
  highlight(){
    if(document.getElementById("zvyrazni_td")){
      let tmp = document.getElementById("zvyrazni_td");
      tmp.removeAttribute("id");
    }
    let plain = document.getElementById("plain-letter_1").value;
    let cipher = document.getElementById("cipher-letter_1").value;
    let p_int = plain.charCodeAt(0);
    let c_int = cipher.charCodeAt(0);
    let pozice = p_int - (c_int - 65) - 64;
    if(pozice < 0)
      pozice = pozice + 26;
    let tabulka = document.getElementById('table_1');
    tabulka.children[0].children[0].children[pozice].id = "zvyrazni_td";
  }
  
  printTable(htmltable){
    var cell;
    htmltable.style.width = window.innerWidth/2+"px";
    htmltable.style.height = window.innerWidth/2+"px";
    htmltable.innerHTML = " ";
    for(let i=0; i<this.newtable.length;i++){
      let tr = htmltable.insertRow(i);
      for(let j=0; j<this.newtable.length;j++){
        if((i==0) || (j==0)){
          cell = document.createElement("th");
            cell.innerHTML = this.newtable[i][j];
            tr.appendChild(cell);
          if((i == 0) && (j == 0)){
            cell.innerHTML = " ";
            tr.appendChild(cell);   
          }
        } else {
          cell = document.createElement("td");
          cell.innerHTML = this.newtable[i][j];
          tr.appendChild(cell);
        }        
      }
    }
  }
}
class inputs{
  constructor(){
    this.value;
  }
  selectColumn(matrix, ascii, table, value){
    let i = 0;
    var num = value.charCodeAt(0)-ascii.firstLetter+1;
    if(matrix.colsclean == true){
      while(table.rows[i] != undefined){
        table.rows[i].cells[num].style.backgroundColor = "lightblue";
        i++;
      }
      matrix.coloredCol = num;
      matrix.colsclean = false;
      matrix.ciphered = false;
    }
  }
  deselectColumn(matrix, ascii, table){
    let i = 0;
    while(table.rows[i] != undefined){
      table.rows[i].cells[matrix.coloredCol].style.backgroundColor = "white";
      i++;
    }
    if((matrix.rowsclean == false) && (matrix.ciphered == false)){
      table.rows[matrix.coloredRow].cells[matrix.coloredCol].style.backgroundColor = "lightblue";
    }
    matrix.colsclean = true;
  }
  selectRow(matrix, ascii, table, value){
    let i = 0;       
    var num = value.charCodeAt(0)-ascii.firstLetter+1;
    while(table.rows[num].cells[i] != undefined){
      table.rows[num].cells[i].style.backgroundColor = "lightblue";
      i++;
    }
    matrix.coloredRow = num;
    matrix.rowsclean = false;
    matrix.ciphered = false;
  }
  deselectRow(matrix, ascii, table){
    let i = 0;
    while(table.rows[matrix.coloredRow].cells[i] != undefined){
      table.rows[matrix.coloredRow].cells[i].style.backgroundColor = "white";
      i++;
    }
    if((matrix.colsclean == false) && (matrix.ciphered == false)){
      table.rows[matrix.coloredRow].cells[matrix.coloredCol].style.backgroundColor = "lightblue";
    }
    matrix.rowsclean = true;
  }
}
class CiphreMachine{
  constructor(){
    this.plaintext;
    this.key;
    this.ciphre;
  }
  extendKey(){
    while(this.key.length < this.plaintext.length){
      this.key = this.key.concat("", this.key);
    }
  }
  cipherManual(matrix, ascii, pl_letter, cip_letter, final){
    var start = ascii.alphabet[0];
    var end = ascii.alphabet.length;
    start = start.charCodeAt(0);
    var p = pl_letter.charCodeAt(0);
    var c = cip_letter.charCodeAt(0);
    var shift = p - start;
    var output = c + shift;
    if(output >= (start + end)){
      output = output - end;
    }
    output = String.fromCharCode(output);
    document.getElementById(final).innerHTML += output;  
    matrix.ciphered = true;
  }
  cipherAuto(ascii){
    this.ciphre = "";
    var i = 0;
    var p, c;
    var start = ascii.alphabet[0];
    var end = ascii.alphabet.length;
    start = start.charCodeAt(0);
    while(this.plaintext.charAt(i) != ''){
      p = this.plaintext.charAt(i).charCodeAt(0);
      c = this.key.charAt(i).charCodeAt(0);
      var shift = p - start;
      let output = c + shift;
      if(output >= (end+start)){
       output = output - end;       
      }
      output = String.fromCharCode(output);
      this.ciphre +=output;
      i++;
    }
  }
  checkCiphre(final){
    let str = document.getElementById(final).innerHTML
    return this.ciphre.localeCompare(str);
  }
}
function loadDefault(plainletter, cipherletter){
  const normal = 97;
  const capital = 65;
  var firstLetter = capital;
  var htmltable = document.getElementById("table");
  var cipheredtext;
  const ascii = new ASCIIarray(firstLetter,firstLetter+26);
  ascii.fillArray();
  const matrix = new table(ascii.alphabet.length+1);
  matrix.buildHeaders(ascii);
  matrix.buildTable(ascii);
  matrix.printTable(htmltable);
  ascii.fillSelect(plainletter);
  ascii.fillSelect(cipherletter);
  const encryptor = new CiphreMachine();
  encryptor.plaintext = "";
  encryptor.key = "";
  const plainInput = new inputs();
  const cipherInput = new inputs();
  document.getElementById(plainletter).addEventListener("input", function(){
    if (matrix.colsclean == true){
      plainInput.selectColumn(matrix, ascii, htmltable, this.value);
    } else {
      plainInput.deselectColumn(matrix, ascii, htmltable);
      plainInput.selectColumn(matrix, ascii, htmltable, this.value);
    }
  });
  document.getElementById(cipherletter).addEventListener("input", function(){
    if (matrix.rowsclean == true){
      cipherInput.selectRow(matrix, ascii, htmltable, this.value);
    } else {
      cipherInput.deselectRow(matrix, ascii, htmltable);
      cipherInput.selectRow(matrix, ascii, htmltable, this.value);
    }
  });
  document.getElementById("button").addEventListener("click", function(){
    var plain = document.getElementById(plainletter).selectedIndex;
    var cipher = document.getElementById(cipherletter).selectedIndex;
    if((plain == -1) || (cipher == -1)){
      print_modal("modal","chyba","Zadejte obě písmena.");
    } else {
      var pl_letter = document.getElementById(plainletter).value;
      var cip_letter = document.getElementById(cipherletter).value;
      encryptor.cipherManual(matrix, ascii, pl_letter, cip_letter, "final");
      plainInput.deselectColumn(matrix, ascii, htmltable);
      cipherInput.deselectRow(matrix, ascii, htmltable);
      document.getElementById(plainletter).selectedIndex = -1;
      document.getElementById(cipherletter).selectedIndex = -1;
      document.getElementById("final").style.backgroundColor = "white";
    }
  });
  document.getElementById("plain").addEventListener("keyup", function(){
    var element = document.getElementById("plain");
    element.value = element.value.replace(/[^A-Z]+/, '');
  });
  document.getElementById("key").addEventListener("keyup", function(){
    var element = document.getElementById("key");
    element.value = element.value.replace(/[^A-Z]+/, '');
  });
  document.getElementById("plain").addEventListener("focusout", function(){
    encryptor.plaintext = this.value;
    if((this.value != "") && (encryptor.key != "")){
      encryptor.extendKey(ascii);
      encryptor.cipherAuto(ascii);
    }
  });
  document.getElementById("key").addEventListener("focusout", function(){
    encryptor.key = this. value;
    if((this.value != "") && (encryptor.plaintext != "")){
      encryptor.extendKey(ascii);
      encryptor.cipherAuto(ascii);
    }
  });
  document.getElementById("check").addEventListener("click", function(){
    var ok = encryptor.checkCiphre("final");
    if(ok == 0){
      document.getElementById("final").style.backgroundColor = "rgba(0,255,0,0.4)";
    } else{
      document.getElementById("final").style.backgroundColor = "rgba(2550,0,0,0.4)";
    }
  });
  //edit: maze se posledni pismenko 
  document.getElementById("reset").addEventListener("click", function(){
    //document.getElementById("plain").value = "";
    //document.getElementById("key").value = "";
    let txt = document.getElementById("final");
    txt.innerHTML = txt.innerHTML.substring(0, txt.innerHTML.length - 1);
  });
}
function upperCaseF(a){
    setTimeout(function(){
        a.value = a.value.toUpperCase();
    }, 1);
}


loadDefault('plain-letter', 'cipher-letter');